/* File:		drawing.c */
/* Description:	This file contains drawing functions */

#include <GL/glut.h>
#include <math.h>
#include "types.h"
#include "maths.h"

/* Function to draw the sky box */

void draw_skybox()
{
	glBegin(GL_QUADS);
		glTexCoord2f(5.0, 0.0);
		glVertex3f(2000.0, -2000.0, 2000.0);
		glTexCoord2f(5.0, 5.0);
		glVertex3f(2000.0, -2000.0, -2000.0);
		glTexCoord2f(0.0, 5.0);
		glVertex3f(-2000.0, -2000.0, -2000.0);
		glTexCoord2f(0.0, 0.0);
		glVertex3f(-2000.0, -2000.0, 2000.0);
	glEnd();
	glBegin(GL_QUADS);
		glTexCoord2f(5.0, 0.0);
		glVertex3f(2000.0, 2000.0, 2000.0);
		glTexCoord2f(0.0, 0.0);
		glVertex3f(-2000.0, 2000.0, 2000.0);
		glTexCoord2f(0.0, 5.0);
		glVertex3f(-2000.0, 2000.0, -2000.0);
		glTexCoord2f(5.0, 5.0);
		glVertex3f(2000.0, 2000.0, -2000.0);
	glEnd();
	glBegin(GL_QUADS);
		glTexCoord2f(5.0, 0.0);
		glVertex3f(2000.0, -2000.0, -2000.0);
		glTexCoord2f(5.0, 5.0);
		glVertex3f(2000.0, 2000.0, -2000.0);
		glTexCoord2f(0.0, 5.0);
		glVertex3f(-2000.0, 2000.0, -2000.0);
		glTexCoord2f(0.0, 0.0);
		glVertex3f(-2000.0, -2000.0, -2000.0);
	glEnd();
	glBegin(GL_QUADS);
		glTexCoord2f(5.0, 0.0);
		glVertex3f(2000.0, -2000.0, 2000.0);
		glTexCoord2f(0.0, 0.0);
		glVertex3f(-2000.0, -2000.0, 2000.0);
		glTexCoord2f(0.0, 5.0);
		glVertex3f(-2000.0, 2000.0, 2000.0);
		glTexCoord2f(5.0, 5.0);
		glVertex3f(2000.0, 2000.0, 2000.0);
	glEnd();
	glBegin(GL_QUADS);
		glTexCoord2f(5.0, 0.0);
		glVertex3f(-2000.0, -2000.0, -2000.0);
		glTexCoord2f(5.0, 5.0);
		glVertex3f(-2000.0, 2000.0, -2000.0);
		glTexCoord2f(0.0, 5.0);
		glVertex3f(-2000.0, 2000.0, 2000.0);
		glTexCoord2f(0.0, 0.0);
		glVertex3f(-2000.0, -2000.0, 2000.0);
	glEnd();
	glBegin(GL_QUADS);
		glTexCoord2f(5.0, 0.0);
		glVertex3f(2000.0, -2000.0, -2000.0);
		glTexCoord2f(0.0, 0.0);
		glVertex3f(2000.0, -2000.0, 2000.0);
		glTexCoord2f(0.0, 5.0);
		glVertex3f(2000.0, 2000.0, 2000.0);
		glTexCoord2f(5.0, 5.0);
		glVertex3f(2000.0, 2000.0, -2000.0);
	glEnd();
}

/* Function to draw a sphere */

void draw_sphere(float r, int detail)
{
 	float a, b;				// angles
	float step;				// angle step
	float upper_band;		// y co-ord of upper vertcies
	float lower_band;		// y co-ord of lower vertices
	float ru, rl;			// radii of upper and lower bands
	world_vector v[4];		// panel vertices
	world_vector n[4];		// vertex normals
	int p, m;				// counters
    float s_step,t_step;
    float t;
    int count=0;

	if (detail < 3)
		detail = 3;
	step = 180.0 / (float)detail;
    s_step = (1.0 / (float)detail)/2.0;
    t_step = 1.0 / (float)detail;

    t = 1.0;
	for (p=0; p<detail; p++)
	{
		a = p * step;
		upper_band = r * cosd(a);
		lower_band = r * cosd(a + step);
		ru = r * sind(a);
		rl = r * sind(a + step);
		for (m=0; m<(detail * 2); m++)
		{
			b = m * step;
			if (p == 0)		// 1st band
			{

				v[0].x = 0.0; v[0].y = r; v[0].z = 0.0;
				n[0].x = 0.0; n[0].y = 1.0; n[0].z = 0.0;
				v[1].x = rl * sind(b); v[1].y = lower_band; v[1].z = rl * cosd(b);
				n[1].x = v[1].x / r; n[1].y = v[1].y / r; n[1].z = v[1].z / r;
				v[2].x = rl * sind(b + step); v[2].y = lower_band; v[2].z = rl * cosd(b + step);
				n[2].x = v[2].x / r; n[2].y = v[2].y / r; n[2].z = v[2].z / r;
				glBegin(GL_TRIANGLES);
					glNormal3f(n[0].x, n[0].y, -n[0].z);
					glTexCoord2f((float)m*s_step,1.0);
   					glVertex3f(v[0].x, v[0].y, -v[0].z);
					glNormal3f(n[2].x, n[2].y, -n[2].z);
					glTexCoord2f((float)(m+1.0)*s_step,1.0-t_step);
                    glVertex3f(v[2].x, v[2].y, -v[2].z);
					glNormal3f(n[1].x, n[1].y, -n[1].z);
			        glTexCoord2f((float)m*s_step,1.0-t_step);
                    glVertex3f(v[1].x, v[1].y, -v[1].z);
                    count++;
				glEnd();

			}
			else if (p == (detail - 1))		// last band
			{

				v[0].x = ru * sind(b); v[0].y = upper_band; v[0].z = ru * cosd(b);
				n[0].x = v[0].x / r; n[0].y = v[0].y / r; n[0].z = v[0].z / r;
				v[1].x = ru * sind(b + step); v[1].y = upper_band; v[1].z = ru * cosd(b + step);
				n[1].x = v[1].x / r; n[1].y = v[1].y / r; n[1].z = v[1].z / r;
				v[2].x = 0.0; v[2].y = -r; v[2].z = 0.0;
				n[2].x = 0.0; n[2].y = -1.0; n[2].z = 0.0;
				glBegin(GL_TRIANGLES);
					glNormal3f(n[1].x, n[1].y, -n[1].z);
					glTexCoord2f((float)(m+1.0)*s_step,0.0+t_step);
					glVertex3f(v[1].x, v[1].y, -v[1].z);
					glNormal3f(n[2].x, n[2].y, -n[2].z);
					glTexCoord2f((float)m*s_step,0.0); 
					glVertex3f(v[2].x, v[2].y, -v[2].z);
					glNormal3f(n[0].x, n[0].y, -n[0].z);
					glTexCoord2f((float)m*s_step,0.0+t_step);
					glVertex3f(v[0].x, v[0].y, -v[0].z);
                    count++;
				glEnd();

			}
			else		// intermediate bands
			{
				v[0].x = ru * sind(b); v[0].y = upper_band; v[0].z = ru * cosd(b);
				n[0].x = v[0].x / r; n[0].y = v[0].y / r; n[0].z = v[0].z / r;
				v[1].x = ru * sind(b + step); v[1].y = upper_band; v[1].z = ru * cosd(b + step);
				n[1].x = v[1].x / r; n[1].y = v[1].y / r; n[1].z = v[1].z / r;
				v[2].x = rl * sind(b + step); v[2].y = lower_band; v[2].z = rl * cosd(b + step);
				n[2].x = v[2].x / r; n[2].y = v[2].y / r; n[2].z = v[2].z / r;
				v[3].x = rl * sind(b); v[3].y = lower_band; v[3].z = rl * cosd(b);
				n[3].x = v[3].x / r; n[3].y = v[3].y / r; n[3].z = v[3].z / r;
				glBegin(GL_QUADS);
					glNormal3f(n[0].x, n[0].y, -n[0].z);
					glTexCoord2f((float)m*s_step,1.0-((float)p*t_step));
					glVertex3f(v[0].x, v[0].y, -v[0].z);
					glNormal3f(n[1].x, n[1].y, -n[1].z);
					glTexCoord2f((float)(m+1.0)*s_step,1.0-((float)p*t_step));
					glVertex3f(v[1].x, v[1].y, -v[1].z);
					glNormal3f(n[2].x, n[2].y, -n[2].z);
					glTexCoord2f((float)(m+1.0)*s_step,1.0-((float)(p+1)*t_step));
					glVertex3f(v[2].x, v[2].y, -v[2].z);
					glNormal3f(n[3].x, n[3].y, -n[3].z);
					glTexCoord2f((float)m*s_step,1.0-((float)(p+1)*t_step));
					glVertex3f(v[3].x, v[3].y, -v[3].z);
                    count++;
				glEnd();
			}
		}
	}
}
